use minifb::Window;

use crate::{cpu::Cpu, video::Renderer};

#[derive(Debug)]
pub struct GeorgeEmu {
    cpu: Cpu,
    renderer: Renderer,
    window: Window,
}

impl GeorgeEmu {
    pub fn new(mut cpu: Cpu, renderer: Renderer, window: Window) -> Self {
        cpu.reset();
        Self {
            cpu,
            renderer,
            window,
        }
    }

    pub fn draw(&mut self) {
        self.renderer.render(Some(&mut self.window));
    }

    pub fn cycle(&mut self) {
        self.cpu.cycle()
    }
}
